#ifndef DUMP_H
#define DUMP_H

#include <vector>

#include "domain.h"

struct node {
    domain_ann	    	    	*domain;
    std::vector<access_ann *>	 accesses;
};

class dumper {
    context_info	   *ctx;
    tree_proc		   *tp;
    symtab_ann 		   *sa;
    int			    root;
public:
    std::vector<node *>	    nodes;
    void scan();
    void dump(int argc, char * argv[]);
    void visit(tree_node *t);
    dumper(tree_proc *t, context_info *ctx) : tp(t), ctx(ctx) {
	sa = (symtab_ann *)tp->peek_annote(k_domain_symtab);
    }
    ~dumper();
};

void dump(tree_proc * tp, context_info *ctx, int argc, char * argv[]);

#endif
